// Code generated by entc, DO NOT EDIT.

package ent

import (
	"fmt"
	"strings"

	"entgo.io/ent/dialect/sql"
	"github.com/valocode/bubbly/ent/adapter"
	"github.com/valocode/bubbly/ent/organization"
)

// Adapter is the model entity for the Adapter schema.
type Adapter struct {
	config `json:"-"`
	// ID of the ent.
	ID int `json:"id,omitempty"`
	// Name holds the value of the "name" field.
	Name string `json:"name,omitempty"`
	// Tag holds the value of the "tag" field.
	Tag string `json:"tag,omitempty"`
	// Module holds the value of the "module" field.
	Module string `json:"module,omitempty"`
	// Edges holds the relations/edges for other nodes in the graph.
	// The values are being populated by the AdapterQuery when eager-loading is set.
	Edges         AdapterEdges `json:"edges"`
	adapter_owner *int
}

// AdapterEdges holds the relations/edges for other nodes in the graph.
type AdapterEdges struct {
	// Owner holds the value of the owner edge.
	Owner *Organization `json:"owner,omitempty"`
	// loadedTypes holds the information for reporting if a
	// type was loaded (or requested) in eager-loading or not.
	loadedTypes [1]bool
}

// OwnerOrErr returns the Owner value or an error if the edge
// was not loaded in eager-loading, or loaded but was not found.
func (e AdapterEdges) OwnerOrErr() (*Organization, error) {
	if e.loadedTypes[0] {
		if e.Owner == nil {
			// The edge owner was loaded in eager-loading,
			// but was not found.
			return nil, &NotFoundError{label: organization.Label}
		}
		return e.Owner, nil
	}
	return nil, &NotLoadedError{edge: "owner"}
}

// scanValues returns the types for scanning values from sql.Rows.
func (*Adapter) scanValues(columns []string) ([]interface{}, error) {
	values := make([]interface{}, len(columns))
	for i := range columns {
		switch columns[i] {
		case adapter.FieldID:
			values[i] = new(sql.NullInt64)
		case adapter.FieldName, adapter.FieldTag, adapter.FieldModule:
			values[i] = new(sql.NullString)
		case adapter.ForeignKeys[0]: // adapter_owner
			values[i] = new(sql.NullInt64)
		default:
			return nil, fmt.Errorf("unexpected column %q for type Adapter", columns[i])
		}
	}
	return values, nil
}

// assignValues assigns the values that were returned from sql.Rows (after scanning)
// to the Adapter fields.
func (a *Adapter) assignValues(columns []string, values []interface{}) error {
	if m, n := len(values), len(columns); m < n {
		return fmt.Errorf("mismatch number of scan values: %d != %d", m, n)
	}
	for i := range columns {
		switch columns[i] {
		case adapter.FieldID:
			value, ok := values[i].(*sql.NullInt64)
			if !ok {
				return fmt.Errorf("unexpected type %T for field id", value)
			}
			a.ID = int(value.Int64)
		case adapter.FieldName:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field name", values[i])
			} else if value.Valid {
				a.Name = value.String
			}
		case adapter.FieldTag:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field tag", values[i])
			} else if value.Valid {
				a.Tag = value.String
			}
		case adapter.FieldModule:
			if value, ok := values[i].(*sql.NullString); !ok {
				return fmt.Errorf("unexpected type %T for field module", values[i])
			} else if value.Valid {
				a.Module = value.String
			}
		case adapter.ForeignKeys[0]:
			if value, ok := values[i].(*sql.NullInt64); !ok {
				return fmt.Errorf("unexpected type %T for edge-field adapter_owner", value)
			} else if value.Valid {
				a.adapter_owner = new(int)
				*a.adapter_owner = int(value.Int64)
			}
		}
	}
	return nil
}

// QueryOwner queries the "owner" edge of the Adapter entity.
func (a *Adapter) QueryOwner() *OrganizationQuery {
	return (&AdapterClient{config: a.config}).QueryOwner(a)
}

// Update returns a builder for updating this Adapter.
// Note that you need to call Adapter.Unwrap() before calling this method if this Adapter
// was returned from a transaction, and the transaction was committed or rolled back.
func (a *Adapter) Update() *AdapterUpdateOne {
	return (&AdapterClient{config: a.config}).UpdateOne(a)
}

// Unwrap unwraps the Adapter entity that was returned from a transaction after it was closed,
// so that all future queries will be executed through the driver which created the transaction.
func (a *Adapter) Unwrap() *Adapter {
	tx, ok := a.config.driver.(*txDriver)
	if !ok {
		panic("ent: Adapter is not a transactional entity")
	}
	a.config.driver = tx.drv
	return a
}

// String implements the fmt.Stringer.
func (a *Adapter) String() string {
	var builder strings.Builder
	builder.WriteString("Adapter(")
	builder.WriteString(fmt.Sprintf("id=%v", a.ID))
	builder.WriteString(", name=")
	builder.WriteString(a.Name)
	builder.WriteString(", tag=")
	builder.WriteString(a.Tag)
	builder.WriteString(", module=")
	builder.WriteString(a.Module)
	builder.WriteByte(')')
	return builder.String()
}

// Adapters is a parsable slice of Adapter.
type Adapters []*Adapter

func (a Adapters) config(cfg config) {
	for _i := range a {
		a[_i].config = cfg
	}
}
